<template>
  <div>
    <v-form ref="loginForm" lazy-validation>
      <div class="login-form">
        <IconifyIcon
          :icon="icons.personIcon"
          class="login-form__icon"
          height="115px"
          width="110px" />
        <div class="login-form__circle"></div>
        <template v-if="stage === 1">
          <v-text-field
            rounded filled
            label="Name"
            class="login-form__field login-form__login-field"
            background-color="#FFFFFF"
            outlined
            :rules="[rules.required, rules.max]"
            v-model="fields.firstName">
          </v-text-field>
          <v-text-field
            rounded filled
            label="Surname"
            class="login-form__field login-form__password-field"
            background-color="#FFFFFF"
            outlined
            :rules="[rules.required, rules.max]"
            v-model="fields.lastName">
          </v-text-field>
          <v-btn
            class="login-form__sign-in dark-btn"
            height="50"
            width="190"
            @click="stage++">NEXT
          </v-btn>
        </template>
        <template v-else>
          <v-text-field
            rounded filled
            label="E-mail"
            class="login-form__field signup-form__login-field"
            background-color="#FFFFFF"
            outlined
            :rules="[rules.required, rules.validEmail]"
            :error-messages="emailErrorMessages"
            v-model="fields.email">
          </v-text-field>
          <v-text-field
            rounded filled
            :type="'password'"
            label="Password"
            class="login-form__field login-form__password-field"
            background-color="#FFFFFF"
            outlined
            :rules="[rules.min]"
            v-model="fields.password">
          </v-text-field>
          <v-text-field
            rounded filled
            :type="'password'"
            label="Repeat password"
            class="login-form__field login-form__password-field"
            background-color="#FFFFFF"
            outlined
            :rules="[rules.passwordsMatch]"
            v-model="fields.passwordRepeat">
          </v-text-field>
          <v-btn
            class="login-form__sign-in dark-btn"
            height="50"
            width="190"
            @click="validateAndSubmit"
            :disabled="submitted">
            Sign Up
          </v-btn>
        </template>
      </div>
    </v-form>
  </div>
</template>

<script>
import IconifyIcon from '@iconify/vue'
import personIcon from '@iconify/icons-bi/person'
import { SignUp } from '@/api/auth'
import { mapMutations } from 'vuex'

export default {
  name: 'Signup',

  components: {
    IconifyIcon
  },

  data() {
    return {
      stage: 1,

      fields: {
        firstName: "",
        lastName: "",
        email: "",
        password: "",
        passwordRepeat: ""
      },

      emailErrorMessages: "",

      submitted: false,

      icons: {
        personIcon
      },

      rules: {
        validEmail: email => /.+@.+\..+/.test(email) || 'E-mail must be valid',
        required: value => !!value || 'Required',
        min: v => (v && v.length >= 8) || 'At least 8 characters',
        max: v => (v && v.length <= 30) || 'Too long',
        passwordsMatch: () => this.fields.password === this.fields.passwordRepeat || "Passwords doesn't match"
      }
    }
  },

  methods: {
    ...mapMutations([
      'updateIsAuthed',
      'updateUserID',
      'updateUserEmail',
      'updateUserFirstName',
      'updateUserLastName',
      'updateUserAvatar',
      'updateIsVerified'
    ]),

    async validateAndSubmit() {
      if (this.$refs.loginForm.validate()) {
        this.submitted = true
        const response = await SignUp(this.fields)
        this.submitted = false

        if (!response.status) {
          return
        }

        if (response.status === 200) {
          this.updateIsVerified(false)
          this.updateIsAuthed(true)
          this.updateUserID(response.data.data.data.id)
          this.updateUserEmail(this.fields.email)
          this.updateUserFirstName(this.fields.firstName)
          this.updateUserLastName(this.fields.lastName)
          this.updateUserAvatar("/dummy.png")

          await this.$router.push('/auth/verification-banner')
          return
        }

        switch (response.status) {
          case 409:
            this.emailErrorMessages = 'This email is already taken'
            break
          default:
            this.$toasted.error('Oh no... Something bad happened')
        }
      }
    }
  }
}
</script>

<style>
.signup-form__login-field {
  margin-top: 53px !important;
}
</style>
